/* 7318 specific definitions - mainly GPIO */
#include <asm/bcm7315.h>

#define BCM_LINUX_CPU_ENET_IRQ          	(29)
#undef BCM_NR_IRQS
#define BCM_NR_IRQS				(136)

/* External IRQ pins (N.B: map to EXTERNAL1_IRQ/EXTERNAL2_IRQ above in mips
 * core cp0 cause/status regs)
 */
#define BCM_LINUX_EXT_IRQ0                      (134)
#define BCM_LINUX_EXT_IRQ1                      (135)

/* Ethernet Controller */

#define BCM_ENET_BASE_7xxx      		(0xFFFD4000)

#define MFN_CTRL0 __preg8 (0xFFFE8008)
#define MFN_CTRL1 __preg8 (0xFFFE8009)
#define MFN_CTRL2 __preg8 (0xFFFE800A)
#define MFN_CTRL3 __preg8 (0xFFFE800B)
#define MFN_CTRL4 __preg8 (0xFFFE800C)
#define MFN_CTRL5 __preg8 (0xFFFE800D)
#define MFN_CTRL6 __preg8 (0xFFFE800E)
#define MFN_CTRL7 __preg8 (0xFFFE800F)
#define MFN_CTRL8 __preg8 (0xFFFE8010)
#define MFN_CTRL9 __preg8 (0xFFFE8011)
#define MFN_CTRLA __preg8 (0xFFFE8012)
#define MFN_CTRLB __preg8 (0xFFFE8013)
#define MFN_CTRLC __preg8 (0xFFFE8014)
#define MFN_CTRLD __preg8 (0xFFFE8015)
#define MFN_CTRLE __preg8 (0xFFFE8016)

#define TGC_GIO_BASE 0xFFFE0050
#define TGC_GIOEXT_BASE 0xFFFE00A0

/* Data */
#define TGC_GIOEXT_OUTHSB   __preg8 (TGC_GIOEXT_BASE + 0x00)
#define TGC_GIOEXT_OUTLSB   __preg8 (TGC_GIOEXT_BASE + 0x01)
#define TGC_GIO_OUTMSB      __preg8 (TGC_GIO_BASE + 0x05)
#define TGC_GIO_OUT2MSB     __preg8 (TGC_GIO_BASE + 0x19)
#define TGC_GIO_OUTHSB      __preg8 (TGC_GIO_BASE + 0x02)
#define TGC_GIO_OUTLSB      __preg8 (TGC_GIO_BASE + 0x03)

/* Direction */
#define TGC_GIOEXT_DIRHSB   __preg8 (TGC_GIOEXT_BASE + 0x02)
#define TGC_GIOEXT_DIRLSB   __preg8 (TGC_GIOEXT_BASE + 0x03)
#define TGC_GIO_DIRMSB      __preg8 (TGC_GIO_BASE + 0x04)
#define TGC_GIO_DIR2MSB     __preg8 (TGC_GIO_BASE + 0x1a)
#define TGC_GIO_DIRHSB      __preg8 (TGC_GIO_BASE + 0x06)
#define TGC_GIO_DIRLSB      __preg8 (TGC_GIO_BASE + 0x07)

/* Open Drain Enable */
#define TGC_GIOEXT_ODHSB    __preg8 (TGC_GIOEXT_BASE + 0x04)
#define TGC_GIOEXT_ODLSB    __preg8 (TGC_GIOEXT_BASE + 0x05)
#define TGC_GIO_ODMSB       __preg8 (TGC_GIO_BASE + 0x00)
#define TGC_GIO_OD2MSB      __preg8 (TGC_GIO_BASE + 0x18)
#define TGC_GIO_ODHSB       __preg8 (TGC_GIO_BASE + 0x01)
#define TGC_GIO_ODLSB       __preg8 (TGC_GIO_BASE + 0x08)

/* Edge configuration */
#define TGC_GIOEXT_ECHSB    __preg8 (TGC_GIOEXT_BASE + 0x06)
#define TGC_GIOEXT_ECLSB    __preg8 (TGC_GIOEXT_BASE + 0x07)
#define TGC_GIO_ECMSB       __preg8 (TGC_GIO_BASE + 0x09)
#define TGC_GIO_EC2MSB      __preg8 (TGC_GIO_BASE + 0x1b)
#define TGC_GIO_ECHSB       __preg8 (TGC_GIO_BASE + 0x0a)
#define TGC_GIO_ECLSB       __preg8 (TGC_GIO_BASE + 0x0b)

/* Edge insensitive */
#define TGC_GIOEXT_EIHSB    __preg8 (TGC_GIOEXT_BASE + 0x08)
#define TGC_GIOEXT_EILSB    __preg8 (TGC_GIOEXT_BASE + 0x09)
#define TGC_GIO_EIMSB       __preg8 (TGC_GIO_BASE + 0x0c)
#define TGC_GIO_EI2MSB      __preg8 (TGC_GIO_BASE + 0x1c)
#define TGC_GIO_EIHSB       __preg8 (TGC_GIO_BASE + 0x0d)
#define TGC_GIO_EILSB       __preg8 (TGC_GIO_BASE + 0x0e)

/* Interrupt mask */
#define TGC_GIOEXT_MASKHSB  __preg8 (TGC_GIOEXT_BASE + 0x0a)
#define TGC_GIOEXT_MASKLSB  __preg8 (TGC_GIOEXT_BASE + 0x0b)
#define TGC_GIO_MASKMSB     __preg8 (TGC_GIO_BASE + 0x0f)
#define TGC_GIO_MASK2MSB    __preg8 (TGC_GIO_BASE + 0x1d)
#define TGC_GIO_MASKHSB     __preg8 (TGC_GIO_BASE + 0x10)
#define TGC_GIO_MASKLSB     __preg8 (TGC_GIO_BASE + 0x11)

/* Interrupt reset */
#define TGC_GIOEXT_RSTHSB   __preg8 (TGC_GIOEXT_BASE + 0x0c)
#define TGC_GIOEXT_RSTLSB   __preg8 (TGC_GIOEXT_BASE + 0x0d)
#define TGC_GIO_RSTMSB      __preg8 (TGC_GIO_BASE + 0x12)
#define TGC_GIO_RST2MSB     __preg8 (TGC_GIO_BASE + 0x1e)
#define TGC_GIO_RSTHSB      __preg8 (TGC_GIO_BASE + 0x13)
#define TGC_GIO_RSTLSB      __preg8 (TGC_GIO_BASE + 0x14)

/* Interrupt status */
#define TGC_GIOEXT_STATHSB  __preg8 (TGC_GIOEXT_BASE + 0x0e)
#define TGC_GIOEXT_STATLSB  __preg8 (TGC_GIOEXT_BASE + 0x0f)
#define TGC_GIO_STATMSB     __preg8 (TGC_GIO_BASE + 0x15)
#define TGC_GIO_STAT2MSB    __preg8 (TGC_GIO_BASE + 0x1f)
#define TGC_GIO_STATHSB     __preg8 (TGC_GIO_BASE + 0x16)
#define TGC_GIO_STATLSB     __preg8 (TGC_GIO_BASE + 0x17)



// GPIOs by function
// Unused
#define S656_CLK    0
#define	S656_0      1
#define	S656_1      2
#define	S656_2      3
#define	S656_3      4
#define	S656_4      5
#define	S656_5      6
#define	S656_6      7
#define	S656_7      8
#define	CLK256FS    19
#define	KEYSCAN0    20
#define	KEYSCAN1    21
#define	KEYSCAN2    22
#define	KEYSCAN3    23
#define	KEYSCAN4    24
#define	TS1_DATA    26
#define	TS1_CLK     27
#define	TS1_ERR     28
#define	TS1_SYNC    29
#define	TS1_VALID   30
#define	DREQ_7042_N 33
#define	DVO_INT_N   37
#define	FPGA_INT_N  38
#define	EBI_DMA_DRQW    39
#define	EBI_DMA_ACKW    40
#define	EBI_DMA_ACKR    41
#define	EBI_DMA_DRQR    42
#define	EBI_DMA_EOP 43
#define UART_RXDA   44
#define UART_RXDB   45
#define UART_TXDA   46
#define UART_TXDB   47

// Default chip pin function
#define	I2S_CLK     9
#define	I2S_LR      10
#define	I2S_DATA    11
#define	MS_IR_OUT   12
#define	CLK_SEC_3_68M   35
#define PKT2_DATA   26
#define PKT2_CLK    27
#define PKT2_ERR    28
#define PKT2_SYNC   29
#define PKT2_VALID  30

// GPIO function
#define	LED_REMOTE  13
#define	LED_RECORD  14
#define	SW_RST_N    15
#define	AVR_RST_N   16
#define	LED_MODEM   17
#define	LED_PWR_ON  18
#define	RF_BYPASS   25
#define	LED_WHITE   31
#define	RST_7042    32
#define	CH_SELECT   35 
#define	NTSC_PAL_N  36

// Gemini/Ghidra only
#define	RST_7042_2  38
#define	RST_7411    38


// Register Bit value for ctrl applied to GPIO pin number A
#define CTRL(A) (1 << ((A) % 8))

// Gpio pin function designator bit values
#define FUNC_CHIP_PIN   0x0
#define FUNC_GPIO       0x1
#define FUNC_ALT2       0x2

// Mask out gpio pin selector function
#define SEL_MASK(A) ~(3 << ((2 * (A)) % 8))

// Select Pin function register bit value for GPIO pin number A
#define SEL_GPIO(A) (FUNC_GPIO << ((2 * (A)) % 8))
#define SEL_CHIP_PIN(A) (FUNC_CHIP_PIN << ((2 * (A)) % 8))
#define SEL_ALT2(A) (FUNC_CHIP_PIN << ((2 * (A)) % 8))

// External interrupt control/mask/status/config reg. (Modem interrupt)
#define BCM_EXTINT		        __INTCREG(0x14)
#define BCM_EXTIRQMASK_SHIFT    24
#define BCM_EXTIRQCLR_SHIFT     16
#define BCM_EXTIRQSTAT_SHIFT    11
#define BCM_EXTIRQCONFIG_SHIFT   0
#define BCM_EXTIRQ_BITMASK      0x3

// I2S pins direction control register
#define TM_I2S_CTRL __preg8 (0xFFFE8024)
