/*
 * tivo-genioctl.h
 * Copyright (C) 2005, 2006 TiVo Inc. All Rights Reserved.
 */

#include<linux/ioctl.h>

#define GIOCTL_IOC_MAGIC        'g'

#define CRASHALLASSRT           _IO(GIOCTL_IOC_MAGIC, 1)
#define UPDATE_EXEC_CTX         _IO(GIOCTL_IOC_MAGIC, 2)
#define TEST_KSTACK_GUARD       _IO(GIOCTL_IOC_MAGIC, 3)
#define TICK_KILLER		_IO(GIOCTL_IOC_MAGIC, 4)

#ifndef __KERNEL__
#include <sys/ioctl.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <linux/tivo-crashallassert.h>

static int gen_ioctl_fd;
inline static void genioctl(int cmd,unsigned int arg)
{
        if ( gen_ioctl_fd <= 0 ) {
                gen_ioctl_fd = open("/dev/gen-ioctl",O_RDONLY);
        }
        if (gen_ioctl_fd >0 ) ioctl(gen_ioctl_fd,(unsigned) cmd,arg);
}

inline static void update_exec_context(const char *str)
{
        struct k_arg arg;
        arg.tag = TAG_EXEC_CTX;
        arg.ptr = (unsigned long) str;
        if(str)
                arg.len = strlen(str);
        else
                arg.len = 0;
        genioctl(UPDATE_EXEC_CTX,(unsigned int)&arg);
}

inline static void kill_tcd_soon(int seconds) {
	genioctl(TICK_KILLER, (unsigned int)(seconds * 100));
}
#endif
